<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/profile.php";
include_once "include/site.php";
include_once "$theme/theme.php";

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

include_once "include/calendar.php";

function update_flash($database, $user_id, $flash_id, $flash_type_id, $flash_manufacturer_id, $flash_model, $flash_variation,
                     $flash_serial_number, $flash_purchase_timestamp, $flash_purchased_new, $flash_access_rights) {

  $flash_date_of_purchase = check_date_validity($flash_purchase_timestamp);

  $flash_model = pg_escape_string($flash_model);
  $flash_variation = pg_escape_string($flash_variation);
  $flash_serial_number = pg_escape_string($flash_serial_number);

  pg_query($database, "begin");
  if ($flash_type_id=='custom') {
    /* flash type has changed */
    $number_of_flashes_of_same_type = pg_fetch_row(pg_query($database, "select count(identifier) from flash where type=(select type from flash where identifier='$flash_id')"));
    if ($number_of_flashes_of_same_type[0] == 1) {
      /* there was only one flash of this kind, so we have to remove it */
      $flash_type_to_remove = pg_fetch_row(pg_query($database, "select type from flash where identifier='$flash_id'"));
    }
    /* create new type */
    $new_flash_type_id = pg_fetch_row(pg_query($database, "select nextval('flash_type_id_sequence')"));
    $flash_type_id = $new_flash_type_id[0];
    $result = pg_query($database, "insert into flash_type (identifier, manufacturer, model, variation, last_modified_date, last_modifying_users)
                                   values ($flash_type_id, $flash_manufacturer_id, '$flash_model', '$flash_variation', now(), $user_id)");
    if (!$result) {
      pg_query($database, "rollback");
      print "Failed to create new flash type";
      return;
    }
  }

  /* add flash */
  $result = pg_query($database, "update flash set type=$flash_type_id, serial_number='$flash_serial_number', date_of_purchase=$flash_date_of_purchase, purchased_new='$flash_purchased_new', access_rights='$flash_access_rights'  where identifier='$flash_id'");
  if (!$result) {
    pg_query($database, "rollback");
    print "Failed to create new flash";
    return;
  }

  /* remove old type */
  if ($flash_type_to_remove) {
    $result = pg_query($database, "delete from flash_type where identifier='$flash_type_to_remove[0]'");
    if (!$result) {
      pg_query($database, "rollback");
      print "Failed to delete flash type: $flash_type";
      return;
    }
  }
  pg_query($database, "commit");
}

$database   = site_prolog();
$my_user_id = pg_fetch_row(pg_query($database, "select identifier from users where session_id='$session_id'"));
if ($my_user_id[0] == "") {
  site_epilog($database);
  header("location: login.php");
  exit();
}

update_flash($database, $my_user_id[0], $_REQUEST['item_id'], $_REQUEST['flash_type_id'], $_REQUEST['flash_manufacturer_id'], $_REQUEST['flash_model'], $_REQUEST['flash_variation'],
             $_REQUEST['flash_serial_number'], $_REQUEST['flash_purchase_timestamp'], $_REQUEST['flash_purchased_new'], $_REQUEST['flash_access_rights']);

site_epilog($database);
header("location: my.profile.php?selector=".$profile_data['flash']['idx']);
?>
