<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "config.php";
include_once "mime.php";
include_once "exif.php";
include_once "iptc.php";
include_once "rdf.php";

function count_storage_space_by_user($database, $user_id) {
  global $image_repository_path;

  $all_photos_of_user = pg_query($database, "
    select small_image_path, medium_image_path, large_image_path
      from photo_version, photo
     where photo.identifier = photo_version.photo
       and photo.users = $user_id");

  $num_of_photos = pg_num_rows($all_photos_of_user);
  $result = array(size => 0, files => 0, directories => 0);

  $result = 0;

  error_reporting(0);
  for ($photo = 0; $photo < $num_of_photos; $photo++) {
    $photo_paths = pg_fetch_row($all_photos_of_user, $i);
    $result += filesize($image_repository_path."/". $photo_paths[0]);
    $result += filesize($image_repository_path."/". $photo_paths[1]);
    $result += filesize($image_repository_path."/". $photo_paths[2]);
  }
  error_reporting(1);
  return $result;
}

function dirsize($directory) {
  $result = array("size" => 0, "files" => 0, "directories" => 0);

  if ($handle = opendir($directory)) {
    while (FALSE !== ($file_name = readdir($handle))) {

      if ($file_name == "." || $file_name == "..")
        continue;

      if (is_dir($directory."/".$file_name)) {
        $sub_results = dirsize($directory."/".$file_name);
        $result['size']        += $sub_results['size'];
        $result['files']       += $sub_results['files'];
        $result['directories'] += $sub_results['directories'] + 1;
      }
      if (is_file($directory."/".$file_name)) {
        $result['size'] += filesize($directory."/".$file_name);
        $result['files'] ++;
      }
    }
    closedir($handle);
  }
  return $result;
}


function get_current_volume($database, $image_file) {
  global $image_repository_path;

  $system_preferences = pg_fetch_row(pg_query($database, "select current_volume, volume_max_size from system_preferences"));
  $new_volume = $system_preferences[0];

  do {
    $dir_size = dirsize($image_repository_path."/". $new_volume);

    if (is_file($image_file)) {
      $image_size = filesize($image_file);
    }
    else {
      $image_size = 0;
    }

    $dir_size['size'] = round($dir_size['size']/1048576, 2);

    /* if size is smaller return the volume as current volume */
    if (($dir_size['size'] + $image_size/1048576) < $system_preferences[1])
      break;

    $new_volume++;
    if (($directory_handle = @opendir($image_repository_path."/".$new_volume))) {
      /* if the next volume check if there is enough space */
      closedir($directory_handle);
      continue;
    }
    else {
      /* if the next volume does not exist, try to create it */
      if (!mkdir($image_repository_path."/".$new_volume, 0700))
        return FALSE;
      if (!mkdir($image_repository_path."/".$new_volume."/00000", 0700))
        return FALSE;
      if (!mkdir($image_repository_path."/".$new_volume."/00001", 0700))
        return FALSE;
      if (!mkdir($image_repository_path."/".$new_volume."/00002", 0700))
        return FALSE;
      break;
    }
  } while (TRUE);

  if ($new_volume != $system_preferences[0])
    pg_query($database, "update system_preferences set current_volume='$new_volume'");

  return $new_volume;
}

function photo_import($database, $index, $im_options, $my_im_composite_options, $dcraw_options, $my_user_id, $default_folder_id, $image_data) {
  global $image_repository_path;
  global $mime_type;

  if (($current_volume = get_current_volume($database, $image_data['file'][$index]['name_tmp'])) == FALSE)
    print "<font color=\"red\">Failed to create new volume in the image repository.</font><br/>";

  pg_query($database, "begin");

  $next_index = pg_fetch_row(pg_query($database, "select nextval('photo_id_sequence')"));
  $image_data['file'][$index]['type'] = strtolower($image_data['file'][$index]['type']);
  $hires_name = $current_volume . "/00000/" . $next_index[0] . "." . $image_data['file'][$index]['type'];

  // we do this to trim the temporary directory name that is used during bulk upload
  $pos = strpos($image_data['file'][$index]['name'], "/");
  if (is_integer($pos)) {
    $original_name = substr($image_data['file'][$index]['name'], strrpos($image_data['file'][$index]['name'], "/") + 1);
  }
  else {
    $original_name = $image_data['file'][$index]['name'];
  }

  $image_data['file'][$index]['original_name'] = $original_name;
  $original_file_type                 = $image_data['file'][$index]['type'];
  $image_data['file'][$index]['type'] = $mime_type[$original_file_type]['out'];
  $multi_page_parameter               = $mime_type[$original_file_type]['page'];
  $mime_type_name                     = $mime_type[$original_file_type]['name'];
  $decoder                            = $mime_type[$original_file_type]['decoder'];
  $postprocessor                      = $mime_type[$original_file_type]['postprocessor'];

  if (!$image_data['file'][$index]['type']) {
    $image_data['file'][$index]['type'] = "jpeg";
  }

  $thumb_name = $current_volume . "/00002/" . $next_index[0] . "." . $image_data['file'][$index]['type'];
  $image_name = $current_volume . "/00001/" . $next_index[0] . "." . $image_data['file'][$index]['type'];

  print "&nbsp;<br/>\n";
  $target_folder = pg_fetch_row(pg_query($database, "select caption, users from folder where identifier = '$image_data[folder]'"));
  if ($target_folder[1] != $my_user_id[0]) {
    print "<font color=\"red\">You do not own the destination folder <a href=folder.php?folder=$image_data[folder]><b>$target_folder[0]</b></a></font>.";
    $image_data['folder'] = $default_folder_id;
    $target_folder = pg_fetch_row(pg_query($database, "select caption from folder where identifier = '$image_data[folder]'"));
  }
  print "Importing the $mime_type_name file <b>".$image_data['file'][$index]['name']."</b> into folder <a href=folder.php?folder=$image_data[folder]><b>$target_folder[0]</b></a><br/>";
  flush();
  print "<ul>";

  $preferences = pg_fetch_row(pg_query($database, "
    select quota_size, quota_count
      from users, preferences
     where preferences.identifier=users.preferences
       and users.identifier=$my_user_id[0]"));

  if ($preferences[0] > 0) {
    $used_storage_space = count_storage_space_by_user($database, $my_user_id[0]);
    $used_storage_space += filesize($image_data['file'][$index]['name_tmp']);
    if ($preferences[0] <= $used_storage_space) {
	  pg_query($database, "rollback");
      error_reporting(0);
      unlink($image_data['file'][$index]['name_tmp']);
      error_reporting(1);
      $preferences[0] /= 1048576;
      print "<li>Your account have reached the storage space quota of $preferences[0] Mb, imposed by your PO adminstrator.<br/>";
      print "No further uploads are possible.</li>";
      print "</ul>";
      return FALSE;
    }
  }

  if ($preferences[1] > 0) {
    $num_of_photo_versions = pg_fetch_row(pg_query($database, "select count_photo_versions_by_user($my_user_id[0])"));
    $num_of_photo_versions++;
    if ($preferences[1] <= $num_of_photo_versions[0]) {
	  pg_query($database, "rollback");
      error_reporting(0);
      unlink($image_data['file'][$index]['name_tmp']);
      error_reporting(1);
      print "<li>Your account have reached the photo quota of $preferences[1] photos including photo versions, imposed by your PO adminstrator.<br/>";
      print "No further uploads are possible.</li>";
      print "</ul>";
      return FALSE;
    }
  }


  if ($image_data['decode_exif'] == 1)
    $image_data = photo_parse_exif($database, $index, $my_user_id[0], $image_data);
  if ($image_data['decode_iptc'] == 1)
    $image_data = photo_parse_iptc($database, $index, $my_user_id[0], $image_data);
  if ($image_data['decode_rdf'] == 1)
    $image_data = photo_parse_rdf($database, $index, $my_user_id[0], $image_data);

  if ($image_data['decode_exif'] == 2)
    $image_data = photo_parse_exif($database, $index, $my_user_id[0], $image_data);
  if ($image_data['decode_iptc'] == 2)
    $image_data = photo_parse_iptc($database, $index, $my_user_id[0], $image_data);
  if ($image_data['decode_rdf'] == 2)
    $image_data = photo_parse_rdf($database, $index, $my_user_id[0], $image_data);

  if ($image_data['decode_exif'] == 3) 
    $image_data = photo_parse_exif($database, $index, $my_user_id[0], $image_data);
  if ($image_data['decode_iptc'] == 3)
    $image_data = photo_parse_iptc($database, $index, $my_user_id[0], $image_data);
  if ($image_data['decode_rdf'] == 3)
    $image_data = photo_parse_rdf($database, $index, $my_user_id[0], $image_data);

  /* DCRAW automatically rotates images! */
  if ($decoder == "dcraw") {
    $image_data["orientation"] = "Normal (O deg)";
  } 

  $orientation = orientation_id_from_string($database, $image_data[orientation]);
  $image_data[orientation_xform] = orientation_to_xform($database, $orientation);

  if (!$image_data[caption])
    $image_data[caption] = "No Caption";

  if (!file_upload($image_data, $index, $im_options, $my_im_composite_options, $dcraw_options, $hires_name, $image_name, $thumb_name, $multi_page_parameter, $decoder, $postprocessor)) {
    pg_query($database, "rollback");
    error_reporting(0);
    print "<li>Cleaning up the mess.</li>";
    unlink($image_repository_path."/".$hires_name);
    unlink($image_repository_path."/".$image_name);
    unlink($image_repository_path."/".$thumb_name);
    error_reporting(1);
    print "</ul>";
    return FALSE;
  }

  $image_data['date_of_exposure'] = check_date_validity($image_data['date_of_exposure']);

  $query = "insert into photo
            (identifier, users, folder, location,
             caption, date_of_exposure, access_rights, copyright_statement,
             views, hide_original, author, title, keyword,
             caption_writer, category, credit, source,
             headline, instructions, transmission_reference,
             supplemental_category, web_statement)
     values ($next_index[0], '$my_user_id[0]', '$image_data[folder]', $image_data[location],
             '$image_data[caption]', $image_data[date_of_exposure], '$image_data[access_rights]', '$image_data[copyright]',
             0, '$image_data[hide_original]', '$image_data[author]', '$image_data[title]', '$image_data[keyword]',
             '$image_data[caption_writer]', '$image_data[category]', '$image_data[credit]', '$image_data[source]',
             '$image_data[headline]', '$image_data[instructions]', '$image_data[transmission_reference]',
             '$image_data[supplemental_category]', '$image_data[web_statement]')";
  $result = pg_query($database, $query);
  if (!$result) {
    pg_query($database, "rollback");
    print "<li><font color=\"red\">Failed to insert rows into photo.</font></li>";
    print "<ul><font color=\"red\">$query</font></ul>";

    error_reporting(0);
    print "<li>Cleaning up the mess.</li>";
    unlink($image_repository_path."/".$hires_name);
    unlink($image_repository_path."/".$image_name);
    unlink($image_repository_path."/".$thumb_name);
    error_reporting(1);
    print "</ul>";
    return FALSE;
  }

  $comment = $image_data['file'][$index]['remark'];

  $orientation = orientation_id_from_string($database, $image_data['orientation']);
  $colorspace = $image_data['colorspace'] == "" ? "1" : $image_data['colorspace'];

  $query = "insert into photo_version(identifier, key, photo, master, small_image_path, medium_image_path, large_image_path, original_image_name, date_of_creation, comment, colorspace, orientation)
                                   values (nextval('photo_version_id_sequence'), 1,  $next_index[0], 't', '$thumb_name', '$image_name', '$hires_name', '$original_name', now(), '$comment', $colorspace, $orientation)";

  $result = pg_query($database, $query);
  if (!$result) {
    pg_query($database, "rollback");
    print "<li><font color=\"red\">Failed to insert rows into photo_version.</li>";
    print "<ul>$query</ul></font>";

    error_reporting(0);
    print "<li>Cleaning up the mess.</li>";
    unlink($image_repository_path."/".$hires_name);
    unlink($image_repository_path."/".$image_name);
    unlink($image_repository_path."/".$thumb_name);
    error_reporting(1);
    print "</ul>";
    return FALSE;
  }

  $storage_location = $image_data['storage_location_type'].$image_data['storage_location_id'];
  $query = "insert into photo_dupe (identifier, key, photo, date_of_creation, storage_location, storage_index, remark)
                                   values (nextval('photo_dupe_id_sequence'), 1, $next_index[0], now(), '$storage_location', '$image_data[storage_index]', 'Original')";
  $result = pg_query($database, $query);

  if (!$result) {
    pg_query($database, "rollback");
    print "<li><font color=\"red\">Failed to insert rows into photo_dupe.</li>";
    print "<ul>$query</ul></font>";
    print "&nbsp;<br/>\n";

    error_reporting(0);
    print "<li>Cleaning up the mess.</li>";
    unlink($image_repository_path."/".$hires_name);
    unlink($image_repository_path."/".$image_name);
    unlink($image_repository_path."/".$thumb_name);
    error_reporting(1);
    print "</ul>";
    return FALSE;
  }

  if ($image_data['camera']         != "null" || $image_data['lens']            != "null" ||
      $image_data['film']           != "null" || $image_data['flash']           != "null" ||
      $image_data['support']        != "null" || $image_data['scanner']         != "null" ||
      $image_data['filter']         != "null" || $image_data['scan_resolution'] != "null" ||
      $image_data['scan_bitdepth']  != "null" || $image_data['scan_multiscan']  != "null" ||
      $image_data['aperture']       != "null" || $image_data['focal_length']    != "null" ||
      $image_data['shutter']        != "null" || $image_data['camera_metering'] != "null" ||
      $image_data['camera_program'] != "null" || $image_data['flash_mode']      != "null" ||
      $image_data['exp_comp']       != "null" || $image_data['flash_comp']      != "null" ||
      $image_data['exif']           != "null" || $image_data['iptc']            != "null" ||
      $image_data['exp_diff']       != "null" || $image_data['iso_override']    != "null") {

    $query = "insert into photo_tech (identifier, photo, camera, lens, film, flash, scanner, filter, scan_resolution, aperture, focal_length, shutter, camera_metering, camera_program, flash_mode, exposure_comp, flash_comp, ev_difference, iso_override, support, scan_bitdepth, scan_multiscan, exif, iptc)
        values (nextval('photo_tech_id_sequence'), $next_index[0], $image_data[camera], $image_data[lens],
                $image_data[film], $image_data[flash], $image_data[scanner],
                $image_data[filter], $image_data[scan_resolution], $image_data[aperture],
                $image_data[focal_length], $image_data[shutter], $image_data[camera_metering],
                $image_data[camera_program], $image_data[flash_mode], $image_data[exp_comp],
                $image_data[flash_comp], $image_data[exp_diff], $image_data[iso_override],
                $image_data[support], $image_data[scan_bitdepth], $image_data[scan_multiscan],
                '$image_data[exif]', '$image_data[iptc]')";
    $result = pg_query($database, $query);
    if (!$result) {
      pg_query($database, "rollback");
      print "<li><font color=\"red\">Failed to insert rows into photo_tech.</li>";
      print "<ul>$query</ul></font>";
      print "&nbsp;<br/>\n";

      error_reporting(0);
      print "<li>Cleaning up the mess.</li>";
      unlink($image_repository_path."/".$hires_name);
      unlink($image_repository_path."/".$image_name);
      unlink($image_repository_path."/".$thumb_name);
      error_reporting(1);
      print "</ul>";
      return FALSE;
    }
  }

  pg_query($database, "commit");
  print "</ul>";
  return $next_index[0];
}

function photo_version_import($database, $index, $im_options, $my_im_composite_options, $dcraw_options, $my_user_id, $photo_id, $image_data) {
  global $image_repository_path;
  global $mime_type;

  $preferences = pg_fetch_row(pg_query($database, "
    select quota_size, quota_count
      from users, preferences
     where preferences.identifier=users.preferences
       and users.identifier=$my_user_id[0]"));

  if ($preferences[0] > 0) {
    $used_storage_space = count_storage_space_by_user($database, $my_user_id[0]);
    $used_storage_space += filesize($image_data['file'][$index]['name_tmp']);
    if ($preferences[0] <= $used_storage_space) {
      print "<li>Your account have reached the storage space quota of $preferences[0] Mb, imposed by your PO adminstrator.<br/>";
      print "No further uploads are possible.</li>";
      print "</ul></p></td></tr></table><p>";
      site_footer($database);
      site_epilog($database);
      exit();
    }
  }

  if ($preferences[1] > 0) {
    $num_of_photo_versions = pg_fetch_row(pg_query($database, "select count_photo_versions_by_user($my_user_id[0])"));
    $num_of_photo_versions++;
    if ($preferences[1] <= $num_of_photo_versions[0]) {
      print "<li>Your account have reached the photo quota of $preferences[1] photos including photo versions, imposed by your PO adminstrator.<br/>";
      print "No further uploads are possible.</li>";
      print "</ul></p></td></tr></table><p>";
      site_footer($database);
      site_epilog($database);
      exit();
    }
  }

  if (($current_volume = get_current_volume($database, $image_data['file'][$index]['name_tmp'])) == FALSE)
    print "<font color=\"red\">Failed to create new volume in the image repository.</font><br/>";

  $next_index = pg_fetch_row(pg_query($database, "select nextval('photo_id_sequence')"));
  $image_data['file'][$index]['type'] = strtolower($image_data['file'][$index]['type']);
  $hires_name = $current_volume . "/00000/" . $next_index[0] . "." . $image_data['file'][$index]['type'];

  // we do this to trim the temporary directory name that is used during bulk upload
  $pos = strpos($image_data['file'][$index]['name'], "/");
  if (is_integer($pos)) {
    $original_name = substr($image_data['file'][$index]['name'], strrpos($image_data['file'][$index]['name'], "/") + 1);
  }
  else {
    $original_name = $image_data['file'][$index]['name'];
  }

  $original_file_type                 = $image_data['file'][$index]['type'];
  $image_data['file'][$index]['type'] = $mime_type[$original_file_type]['out'];
  $multi_page_parameter               = $mime_type[$original_file_type]['page'];
  $mime_type_name                     = $mime_type[$original_file_type]['name'];
  $decoder                            = $mime_type[$original_file_type]['decoder'];
  $postprocessor                      = $mime_type[$original_file_type]['postprocessor'];

  if (!$image_data['file'][$index]['type']) {
    $image_data['file'][$index]['type'] = "jpeg";
  }

  $thumb_name = $current_volume . "/00002/" . $next_index[0] . "." . $image_data['file'][$index]['type'];
  $image_name = $current_volume . "/00001/" . $next_index[0] . "." . $image_data['file'][$index]['type'];

  $photo_data = pg_fetch_row(pg_query($database, "
    select caption
      from photo
     where photo.identifier = '$photo_id'"));

  print "&nbsp;<br/>\n";
  print "Importing the $mime_type_name file <b>".$image_data['file'][$index]['name']."</b> as a new version of <a href=\"photo.php?photo=$photo_id&detail_info=5\"><b>$photo_data[0]</b></a><br/>";
  flush();
  print "<ul>";

  $master = $image_data['file'][$index]['master'];
  if (!file_upload($image_data, $index, $im_options, $my_im_composite_options, $dcraw_options, $hires_name, $image_name, $thumb_name, $multi_page_parameter, $decoder, $postprocessor)) {
    error_reporting(0);
    print "<li>Cleaning up the mess.</li>";
    unlink($image_repository_path ."/" .$hires_name);
    unlink($image_repository_path ."/" .$image_name);
    unlink($image_repository_path ."/" .$thumb_name);
    error_reporting(1);
    print "</ul>";
    return FALSE;
  }

  pg_query($database, "begin");

  if ($master == 't') {
    $query = "update photo_version set master='f' where photo=$photo_id";
    $result = pg_query($database, $query);
    if (!$result) {

      print "<li><font color=\"red\">Failed to insert rows into photo_tech.</li>";
      print "<ul>$query</ul></font>";
      print "&nbsp;<br/>\n";

      pg_query($database, "rollback");
      error_reporting(0);
      print "<li>Cleaning up the mess.</li>";
      unlink($image_repository_path ."/" .$hires_name);
      unlink($image_repository_path ."/" .$image_name);
      unlink($image_repository_path ."/" .$thumb_name);
      error_reporting(1);
      print "</ul>";
      return FALSE;
    }
  }

  $key = pg_fetch_row(pg_query($database, "select max(key) from photo_version where photo=$photo_id"));
  $key[0] = $key[0] + 1;

  $comment = $image_data['file'][$index]['remark'];
  $pos = strpos($image_data['file'][$index]['name'], "/");
  if (is_integer($pos)) {
    $original_name = substr($image_data['file'][$index]['name'], strrpos($image_data['file'][$index]['name'], "/") + 1);
  }
  else {
    $original_name = $image_data['file'][$index]['name'];
  }

  $orientation = orientation_id_from_string($database, $image_data['orientation']);
  $colorspace = $image_data['colorspace'] == "" ? "1" : $image_data['colorspace'];

  $query = "insert into photo_version (identifier, key, photo, master, small_image_path, medium_image_path, large_image_path, original_image_name, date_of_creation, comment, colorspace, orientation)
            values (nextval('photo_version_id_sequence'), '$key[0]', '$photo_id', '$master', '$thumb_name', '$image_name', '$hires_name', '$original_name', now(), '$comment', $colorspace, $orientation)";
  $result = pg_query($database, $query);
  if (!$result) {
    print "<li><font color=\"red\">Failed to insert rows into photo_version.</li>";
    print "<ul>$query</ul></font>";
    print "&nbsp;<br/>\n";
    pg_query($database, "rollback");
    error_reporting(0);
    print "<li>Cleaning up the mess.</li>";
    unlink($image_repository_path ."/" .$hires_name);
    unlink($image_repository_path ."/" .$image_name);
    unlink($image_repository_path ."/" .$thumb_name);
    error_reporting(1);
    print "</ul>";
    return FALSE;
  }

  pg_query($database, "commit");
  print "</ul>";
  return TRUE;
}

function import_raw_decode($input_file_name, $dcraw_options, $decoder, $postprocessor, $verbose) {
  global $sys_dcraw;

  if ($decoder != "dcraw")
    return FALSE;

  $temporary_file_name = tempnam($tmp_volume_path, "po");
  unlink($temporary_file_name);
  $temporary_file_name = $temporary_file_name . ".ppm";

  if ($verbose) {
	print "<li>Decoding raw image ...";
  }

//  Gamma ($raw_options [0]) is gone completely!
  $options = " -q 3 -b $dcraw_options[1] -r $dcraw_options[3] -l $dcraw_options[4]";
  switch ($dcraw_options[2]) {
  case "automatic":
    $options = $options . " -a";
    break;
  case "camera":
    $options = $options . " -w";
  }
  switch ($dcraw_options[5]) {
  case 24:
    $options = $options . " -2";
    break;
  case 48:
    $options = $options . " -4";
  }

  system("$sys_dcraw $options -c " . escapeshellarg($input_file_name) . " > $temporary_file_name ", $retval_decoding);

  if ($retval_decoding) {
	if ($verbose) {
	  print "<font color=\"red\"> failed. ($sys_dcraw $options $input_file_name $retval_decoding) </font></li>";
	}
	return FALSE;
  }

  if ($verbose) {
	print " done.</li>";
	flush();
  }

  /* the decoder generates ppm files so transform the file name */
  return $temporary_file_name;
}

function import_generate_thumbnail($input_file_name, $thumb_name, $verbose, $im_options, $multi_page_parameter, $orientation, $colorspace)
{
  global $image_repository_path;
  global $sys_convert;
  global $thumb_max_size;
  global $icc_profiles;

  if (($im_options[13] != 0) && ($im_options[14] != 0))
    $im_framing_option = " -frame " . escapeshellarg($im_options[13]  ."x". $im_options[14]);
  else
    $im_framing_option = "";

  if ($colorspace != "" && $colorspace > "1") {
    $im_profile_option = "-profile " . $icc_profiles[1]['file'] . " +profile icm";

    if ($colorspace != "99") {
      $im_profile_option = "+profile icm -profile " . $icc_profiles[$colorspace]['file'] . " $im_profile_option";
    }
  } else {
    $im_profile_option = "";
  }

  /* generate thumbnail */
  $cmdline = "$sys_convert".
         " -geometry " .   escapeshellarg($thumb_max_size  ."x". $thumb_max_size) ."\> ".
         " -unsharp ".     escapeshellarg($im_options[11]  ."x". $im_options[12] ."+". $im_options[18] ."+". $im_options[19]) ." ".
         " -mattecolor " . escapeshellarg("#".$im_options[15]) ." ".
         $im_framing_option ." ".
	 $orientation ." ".
         $im_profile_option ." ".
         " -colorspace " . escapeshellarg($im_options[9])  ." ".
         " -gamma " .      escapeshellarg($im_options[10]) ." ".
         " -quality " .    escapeshellarg($im_options[8])  ." ".
         escapeshellarg($input_file_name).escapeshellarg($multi_page_parameter)." ".
         escapeshellarg($thumb_name);

	system($cmdline, $retval_thumb_scaling);


  if ($retval_thumb_scaling) {
    if ($verbose) {
      print "<li><font color=\"red\">Thumbnail generation failed.</font></li>";
      print "<li><fonr color=\"red\">$cmdline</font></li>";
    }
    return FALSE;
  }

  if ($verbose) {
    print "<li>Thumbnail <b>$thumb_name</b> of $thumb_max_size pixels generated.</li>";
    flush();
  }

  return TRUE;
}

function import_generate_preview($input_file_name, $image_name, $verbose, $im_options, $my_im_composite_options, $multi_page_parameter, $orientation, $colorspace) {
  global $image_repository_path;
  global $sys_convert;
  global $sys_composite;
  global $image_max_size;
  global $icc_profiles;

  /* matting options */
  if (($im_options[5] != 0) && ($im_options[6] != 0))
    $im_framing_option = " -frame " . escapeshellarg($im_options[5]  ."x". $im_options[6]);
  else
    $im_framing_option = "";

  if ($colorspace != "" && $colorspace > "1") {
    $im_profile_option = "-profile " . $icc_profiles[1]['file'] . " +profile icm";

    if ($colorspace != "99") {
      $im_profile_option = "+profile icm -profile " . $icc_profiles[$colorspace]['file'] . " $im_profile_option";
    }
  } else {
    $im_profile_option = "";
  }

  /* generate preview */
  $cmdline = "$sys_convert".
         " -geometry " .   escapeshellarg($image_max_size ."x". $image_max_size) ."\> ".
         " -unsharp " .    escapeshellarg($im_options[3]  ."x". $im_options[4] ."+". $im_options[16] ."+". $im_options[17] ) ." ".
         " -mattecolor " . escapeshellarg("#".$im_options[7]) ." ".
         $im_framing_option ." ".
         $orientation ." ".
         $im_profile_option ." ".
         " -colorspace " . escapeshellarg($im_options[1]) ." ".
         " -gamma " .      escapeshellarg($im_options[2]) ." ".
         " -quality " .    escapeshellarg($im_options[0]) ." ".
         escapeshellarg($input_file_name).escapeshellarg($multi_page_parameter)." ".
         escapeshellarg($image_name);

  system($cmdline, $retval_image_scaling);

  if ($retval_image_scaling) {
	if ($verbose) {
	    print "<li><font color=\"red\">Preview generation failed.</font></li>";
	    print "<li><fonr color=\"red\">$cmdline</font></li>";
	}
    return FALSE;
  }

  if ($verbose) {
    print "<li>Preview <b>$image_name</b> of $image_max_size pixels created.</li>";
    flush();
  }

  /* watermark preview */
  if ($my_im_composite_options[0] && $my_im_composite_options[1] && $my_im_composite_options[2]) {
    system("$sys_composite".
           " -gravity " .  escapeshellarg($my_im_composite_options[0]) .
           " -watermark " .  escapeshellarg($my_im_composite_options[1]) ." ".
           escapeshellarg($image_repository_path."/".$my_im_composite_options[3]) ." ".
           escapeshellarg($image_name)." ".
           escapeshellarg($image_name), $retval_watermarking);
    if ($retval_watermarking) {
	if ($verbose) {
          print "<li><font color=\"red\">Watermarking failed.</font></li>";
	}
      return FALSE;
    }

    if ($verbose) {
      print "<li>Watermarking preview <b>$image_name</b>.</li>";
      flush();
    }
  }
  return TRUE;
}

function file_upload($image_data, $index, $im_options, $my_im_composite_options, $dcraw_options, $hires_name, $image_name, $thumb_name, $multi_page_parameter, $decoder, $postprocessor) {
  global $image_repository_path;
  $success = true;

  if ($image_data['file'][$index]['name_tmp']) {
    /* copy the original to the repository */
    if (!copy($image_data['file'][$index]['name_tmp'], $image_repository_path."/".$hires_name)) {
      print "<li><font color=\"red\">Copying <b>".$image_data['file'][$index]['name']."</b></font> failed [cp ".$image_data['file'][$index]['name_tmp']." $image_repository_path/$hires_name]</li>";
    } else {
      print "<li>Copying <b>".$image_data['file'][$index]['name']."</b> into <b>$image_repository_path/$hires_name</b></li>";
    }
    flush();

    $temporary_ppm_file = import_raw_decode($image_data['file'][$index]['name_tmp'], $dcraw_options, $decoder, $postprocessor, TRUE);
    if ($temporary_ppm_file) {
      unlink($image_data['file'][$index]['name_tmp']);
      $image_data['file'][$index]['name_tmp'] = $temporary_ppm_file;
    }

    $return_value = import_generate_preview($image_data['file'][$index]['name_tmp'], $image_repository_path ."/". $image_name, TRUE, $im_options, $my_im_composite_options, $multi_page_parameter, $image_data["orientation_xform"], $image_data['colorspace']);
    if (!$return_value) {
      $success = false;
      unlink($input_file_name);
    }

    $return_value = import_generate_thumbnail($image_data['file'][$index]['name_tmp'], $image_repository_path ."/". $thumb_name, TRUE, $im_options, $multi_page_parameter, $image_data["orientation_xform"], $image_data['colorspace']);
    if (!$return_value) {
      unlink($input_file_name);
      $success=false;
    }

    /* remove temporary file */
    unlink($image_data['file'][$index]['name_tmp']);
  }

  return $success;
}

?>
