<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/site.php";
include_once "$theme/theme.php";

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

include_once "include/common.php";
include_once "include/site.php";
include_once "include/import.php";

$database = site_prolog();
$my_user_id = pg_fetch_row(pg_query($database, "
    select identifier, type
      from users
     where session_id='$session_id'"));

if ($my_user_id[1] < $user_type['administrator']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$system_preferences = pg_fetch_row(pg_query($database, "
    select user_type.value, new_user_bulk_upload_enable, paper.name, new_user_label, current_volume, volume_max_size, new_user_shop_enable,
           new_user_quota_size, new_user_quota_count
      from system_preferences, user_type, paper, label
     where system_preferences.new_user_type=user_type.identifier
       and system_preferences.new_user_paper = paper.identifier"));

print "<h1>Photo Organizer</h1>";
print "<h2>Version 2.13-2.14</h2>";
print "<h2>Image Repository Migration</h2>";
print "&nbsp;<br/>\n";

$conversion = array(array("desc" => "originals",  "prefix" => "hires", "sql_field" => "large_image_path",  "subvolume" => "00000"),
                    array("desc" => "previews",   "prefix" => "image", "sql_field" => "medium_image_path", "subvolume" => "00001"),
                    array("desc" => "thumbnails", "prefix" => "thumb", "sql_field" => "small_image_path",  "subvolume" => "00002"));

if ($handle = opendir($image_repository_path)) {

  /* CONVERT EACH VOLUME IN THE IMAGE REPOSITORY */
  while (false !== ($directory = readdir($handle))) {
    if ($directory == "." || $directory == "..")
      continue;

    $volume = $image_repository_path ."/". $directory;
    print "&nbsp;<br/>\n";
    print "Migrating volume <b>" . $volume . "</b>";
    print "<ul>";

    /* FOR EACH FORMAT REPEAT THE FOLLOWING 3 STEPS */
    foreach ($conversion as $conv) {
      print "<li>Processing " . $conv['desc'];
      print "<ul>";
      $subdir = $volume ."/" . $conv['subvolume'];
      /* STEP 1 - CREATE NEW SUB-VOLUME */
      print "<li>Creating subdirectory <b>". $subdir ."</b> ... ";
      $result = mkdir($subdir);
      if ($result)
        print "<font color=\"green\"><b>OK</b></font>";
      else {
        print "<font color=\"red\"><b>FAILED</b></font>";
      }
      print "</li>";

      /* STEP 2 - MOVE THE APROPRIATE IMAGE FILES */
      $sql_field = $conv['sql_field'];
      $images_in_this_volume = pg_query($database, "
       select photo,
              $sql_field,
              (substr($sql_field,  char_length('$directory')+2)) as short
         from photo_version
        where '$directory' = substr($sql_field,  0, char_length('$directory') +1 )");

      $num_of_files = pg_num_rows($images_in_this_volume);
      for ($idx = 0; $idx < $num_of_files; $idx++) {
        $image = pg_fetch_row($images_in_this_volume, $idx);
        $image[2] = substr($image[2], 5);
        print "<li>Moving <b>". $image_repository_path . "/". $image[1] ."</b> to <b>". $subdir ."/". $image[2]. "</b> ... ";
        $result = rename($image_repository_path . "/". $image[1], $subdir ."/". $image[2]);
        if ($result)
          print "<font color=\"green\"><b>OK</b></font>";
        else {
          print "<font color=\"red\"><b>FAILED</b></font>";
        }
        print "</li>";
      }

      /* STEP 3 - UPDATE THE DATABASE */
      print "<li>Updating database ... ";
      $result = pg_query($database, "
       update photo_version
          set $sql_field = ('".$directory."/".$conv['subvolume'] ."/' || (substr($sql_field,  char_length('".$directory."/".$conv['prefix']."') + 1)))
        where '".$directory."/".$conv['prefix']."' = substr($sql_field,  0, char_length('".$directory."/".$conv['prefix']."') +1 )");

      if ($result)
        print "<font color=\"green\"><b>OK</b></font>";
      else {
        print "<font color=\"red\"><b>FAILED</b></font>";
      }
      print "</li>";

      print "</ul>";
      print "</li>";
    }
    print "</ul>";
  }
  closedir($handle);
}

print "&nbsp;<br/>\n";
print "Done";
print "&nbsp;<br/>\n";


site_epilog($database);
?>
