<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "$theme/theme.php";

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

include_once "include/site.php";
include_once "include/common.php";
include_once "include/site.php";

$database = site_prolog();
$my_user_id = pg_fetch_row(pg_query($database, "select identifier, type from users where session_id='$session_id'"));
if ($my_user_id[1] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$photo_id               = $_REQUEST['photo'];
$author                 = pg_escape_string($_REQUEST['author']);
$title                  = pg_escape_string($_REQUEST['title']);
$keyword                = pg_escape_string($_REQUEST['keyword']);
$caption                = pg_escape_string($_REQUEST['caption']);
$caption_writer         = pg_escape_string($_REQUEST['caption_writer']);
$web_statement          = pg_escape_string($_REQUEST['web_statement']);
$copyright              = pg_escape_string($_REQUEST['copyright']);
$supplemental_category  = pg_escape_string($_REQUEST['supplemental_category']);
$category               = substr(pg_escape_string($_REQUEST['category']), 0, 3);
$credit                 = pg_escape_string($_REQUEST['credit']);
$source                 = pg_escape_string($_REQUEST['source']);
$headline               = pg_escape_string($_REQUEST['headline']);
$instructions           = pg_escape_string($_REQUEST['instructions']);
$transmission_reference = pg_escape_string($_REQUEST['transmission_reference']);

$full_date_of_exposure = check_date_validity($_REQUEST['full_date_of_exposure']);
$date_of_exposure = check_date_validity($_REQUEST['exposure_timestamp']);

$location         = $_REQUEST['location'];
$access_rights    = $_REQUEST['access_rights'];
$hide_original    = $_REQUEST['hide_original'];

$camera           = $_REQUEST['camera'];
$lens             = $_REQUEST['lens'];
$filter           = $_REQUEST['filter'];
$film             = $_REQUEST['film'];
$flash            = $_REQUEST['flash'];
$scanner          = $_REQUEST['scanner'];
$focal_length     = $_REQUEST['focal_length'];
$aperture         = $_REQUEST['aperture'];
$shutter          = $_REQUEST['shutter'];
$exp_comp         = $_REQUEST['exp_comp'];
$exp_diff         = $_REQUEST['exp_diff'];
$camera_metering  = $_REQUEST['camera_metering'];
$camera_program   = $_REQUEST['camera_program'];
$flash_mode       = $_REQUEST['flash_mode'];
$flash_comp       = $_REQUEST['flash_comp'];
$scan_resolution  = $_REQUEST['scan_resolution'];
$scan_bitdepth    = $_REQUEST['scan_bitdepth'];
$scan_multiscan   = $_REQUEST['scan_multiscan'];
$iso_override     = $_REQUEST['iso_override'];
$support          = $_REQUEST['support'];

$file_type = substr($file_type, strpos($file_type, "/") + 1);
$result = pg_query($database, "begin");


/* this will enable administrators to edit photos */
if ($my_user_id[1] == $user_type['administrator']) {
  $user_id = pg_fetch_row(pg_query($database, "select users from photo where identifier='$photo_id'"));
}
if (!$user_id) {
  $user_id = $my_user_id;
}

$user_name = pg_fetch_row(pg_query($database, "
  select identifier, last_name, first_name
    from users
   where identifier=$user_id[0]"));

if (substr($full_date_of_exposure, 0, 10) == $date_of_exposure) {
  $date_of_exposure = $full_date_of_exposure;
}

$query = "update photo
     set location               = $location,
         author                 = '$author',
         title                  = '$title',
         keyword                = '$keyword',
         caption                = '$caption',
         caption_writer         = '$caption_writer',
         web_statement          = '$web_statement',
         supplemental_category  = '$supplemental_category',
         copyright_statement    = '$copyright',
         credit                 = '$credit',
         source                 = '$source',
         headline               = '$headline',
         instructions           = '$instructions',
         transmission_reference = '$transmission_reference',
         date_of_exposure       = $date_of_exposure,
         access_rights          = $access_rights,
         hide_original          = '$hide_original'
         where identifier = $photo_id
     and users = $user_id[0]";

$result = pg_query($database, $query);
if (!$result) {
  pg_query($database, "rollback");
  site_epilog($database);
  header("location: photo.php?photo=$photo_id");
  exit();
}

if (pg_num_rows(pg_query($database, "select identifier from photo_tech where photo=$photo_id")) > 0) {
  $result = pg_query($database, "
    update photo_tech
       set camera=$camera,
           lens=$lens,
           film=$film,
           flash=$flash,
           scanner=$scanner,
           filter=$filter,
           scan_resolution=$scan_resolution,
           aperture=$aperture,
           focal_length=$focal_length,
           shutter=$shutter,
           camera_metering=$camera_metering,
           camera_program=$camera_program,
           flash_mode=$flash_mode,
           exposure_comp=$exp_comp,
           flash_comp=$flash_comp,
           ev_difference=$exp_diff,
           iso_override=$iso_override,
           support=$support,
           scan_bitdepth=$scan_bitdepth,
           scan_multiscan=$scan_multiscan
     where photo=$photo_id");
  if (!$result) {
    pg_query($database, "rollback");
    site_epilog($database);
    header("location: photo.php?photo=$photo_id");
    exit();
  }
}
else {
  if ($camera != "null"       || $lens != "null"         || $film != "null"            || $flash != "null"           || $support != "null" ||
      $scanner != "null"      || $filter != "null"       || $scan_resolution != "null" || $scan_bitdepth != "null"   || $scan_multiscan != "null" ||
      $aperture != "null"     || $focal_length != "null" || $shutter != "null"         || $camera_metering != "null" || $camera_program != "null" ||
      $flash_mode != "null"   || $exp_comp != "null"     || $flash_comp != "null"      || $exp_diff != "null"        || $iso_override != "null") {
    $result = pg_query($database, "
       insert into photo_tech
              (identifier, photo, camera, lens,  film, flash, scanner,
               filter, scan_resolution, aperture, focal_length, shutter,
               camera_metering, camera_program, flash_mode, exposure_comp,
               flash_comp, ev_difference, iso_override, support, scan_bitdepth,
               scan_multiscan)
       values (nextval('photo_tech_id_sequence'), $photo_id, $camera, $lens, $film, $flash, $scanner,
               $filter, $scan_resolution, $aperture, $focal_length, $shutter,
               $camera_metering, $camera_program, $flash_mode, $exp_comp,
               $flash_comp, $exp_diff, $iso_override, $support, $scan_bitdepth,
               $scan_multiscan)");
    if (!$result) {
      pg_query($database, "rollback");
      site_epilog($database);
      header("location: photo.php?photo=$photo_id");
      exit();
    }
  }
}

$result = pg_query($database, "commit");
site_epilog($database);

header("location: photo.php?photo=$photo_id");
?>
