
--  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.18 to v2.19 patch
----------------------------------------------------------

-- create shop category table
create sequence shop_category_id_sequence start 1;
create table shop_category (
  identifier            integer not null primary key,
  users                 integer not null references users(identifier),
  caption               varchar(300),
  date_of_creation      timestamp
);

-- populate the table with 'Prints'
insert into shop_category
            (identifier,  users, caption, date_of_creation)
      select nextval('shop_category_id_sequence') as identifier,
             users.identifier as users,
             'Prints' as caption,
             now() as date_of_creation
        from users;

alter table photo_format add column description varchar(200);
alter table photo_format add column category integer references shop_category(identifier);

-- and migrate existing photo_formats to this category
update photo_format set category = shop_category.identifier where photo_format.users = shop_category.users;

-- now that we have the categories updated set them not null
alter table photo_format alter column category set not null;

-- update the photo_format so that we have only one description field
update photo_format set description = width || 'x' || height;

-- drop old columns from photo_format
alter table photo_format drop column width;
alter table photo_format drop column height;

alter table photo_format rename to shop_item;

create sequence shop_item_id_sequence start 1;
select setval('shop_item_id_sequence', nextval('photo_format_id_sequence'));
drop sequence photo_format_id_sequence;

alter table photo_item rename column format to shop_item;

alter table shop_order add column download_counter integer;
alter table shop_order add column download_expiry_date date;

alter table client add trusted char check (trusted in ('t', 'f'));

drop view view_client;
create view view_client as
  select client.identifier, client.users, client.client, users.last_name,
         users.first_name, date_of_creation, client_status.value, client.status, users.type,
         client.trusted
    from client, users, client_status
   where client.client = users.identifier
     and client.status = client_status.identifier
   order by users.last_name, users.first_name;

alter table preferences add column download_counter integer;
alter table preferences add column download_expiry_period integer;
