<?php

//  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/site.php";
include_once "include/search.2.php";
include_once "$theme/theme.php";

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

$database   = site_prolog();
$my_user_id = pg_fetch_row(pg_query($database, "select identifier, type from users where session_id='$session_id'"));
if ($my_user_id[0] == "") {
  site_epilog($database);
  header("location: login.php");
  exit();
}

/* this will enable administrators to empty anybody's trash */
if ($my_user_id[1] == $user_type['administrator']) {
  $user_id = $_REQUEST['user'];
}
if (!$user_id) {
  $user_id = $my_user_id[0];
}

$trash_folder_id = pg_fetch_row(pg_query($database, "select identifier from folder where users=$user_id and caption='Trash'"));
$photos_in_trash = pg_query($database, "
  select small_image_path, medium_image_path, large_image_path, photo.identifier
    from photo, photo_version
   where photo.identifier = photo_version.photo
     and photo.folder = '$trash_folder_id[0]'");

$num_of_photos_in_trash = pg_num_rows($photos_in_trash);
pg_query($database, "begin");

// update the imagemagick_composite_options table if the photo is a selected watermark mask
$result = pg_query($database, "update imagemagick_composite_options set photo_version = null where photo_version in (select identifier from photo_version where photo in (select identifier from photo where folder='$trash_folder_id[0]'))");
if (!$result) {
  pg_query($database, "rollback");
  site_epilog($database);
  header("location: user.php?user=$user_id");
  exit();
}

// remove all submission entries
$result = pg_query($database, "delete from photo_spooler where photo in (select identifier from photo where folder='$trash_folder_id[0]')");
if (!$result) {
  pg_query($database, "rollback");
  site_epilog($database);
  header("location: user.php?user=$user_id");
  exit();
}
// remove references in albums
$result = pg_query($database, "delete from album_content where photo in (select identifier from photo where folder='$trash_folder_id[0]')");
if (!$result) {
  pg_query($database, "rollback");
  site_epilog($database);
  header("location: user.php?user=$user_id");
  exit();
}
// remove all submission entries
$result = pg_query($database, "delete from submission where photo_dupe in (select photo_dupe.identifier from photo, photo_dupe where photo_dupe.photo=photo.identifier and photo.folder='$trash_folder_id[0]')");
if (!$result) {
  pg_query($database, "rollback");
  site_epilog($database);
  header("location: user.php?user=$user_id");
  exit();
}
// remove all photo_dupe entries first
$result = pg_query($database, "delete from photo_dupe where photo in (select identifier from photo where folder='$trash_folder_id[0]')");
if (!$result) {
  pg_query($database, "rollback");
  site_epilog($database);
  header("location: user.php?user=$user_id");
  exit();
}
// remove all photo_version entries first
$result = pg_query($database, "delete from photo_version where photo in (select identifier from photo where folder='$trash_folder_id[0]')");
if (!$result) {
  pg_query($database, "rollback");
  site_epilog($database);
  header("location: user.php?user=$user_id");
  exit();
}
// remove all photo_tech entries first
$result = pg_query($database, "delete from photo_tech where photo in (select identifier from photo where folder='$trash_folder_id[0]')");
if (!$result) {
  pg_query($database, "rollback");
  site_epilog($database);
  header("location: user.php?user=$user_id");
  exit();
}

$result = pg_query($database, "delete from rating where photo in (select identifier from photo where folder='$trash_folder_id[0]')");
if (!$result) {
  pg_query($database, "rollback");
  site_epilog($database);
  header("location: user.php?user=$user_id");
  exit();
}

/* WE NO LONGER WANT TO REMOVE PHOTOS THAT WERE INVOLVED IN A SHOP TRANSACTION */
/* INSTEAD WE MOVE THEM INTO THE ORPHANAGE */
/* $result = pg_query($database, " */
/*   delete from shop_order */
/*    where item in (select photo_item.identifier */
/*                     from photo_item, photo */
/*                    where photo_item.photo=photo.identifier */
/*                      and folder='$trash_folder_id[0]') */
/*       or client='$user_id'"); */
/* if (!$result) { */
/*   pg_query($database, "rollback"); */
/*   site_epilog($database); */
/*   header("location: admin.php"); */
/*   exit(); */
/* } */

/* $result = pg_query($database, " */
/*   delete from shop_transaction */
/*    where identifier in (select shop_order.transaction */
/*                           from shop_order, photo_item, photo */
/*                          where shop_order.item=photo_item.identifier */
/*                            and photo_item.photo=photo.identifier */
/*                            and folder='$trash_folder_id[0]')"); */
/* if (!$result) { */
/*   pg_query($database, "rollback"); */
/*   site_epilog($database); */
/*   header("location: admin.php"); */
/*   exit(); */
/* } */

/* $result = pg_query($database, "delete from photo_item where photo in (select identifier from photo where folder='$trash_folder_id[0]')"); */
/* if (!$result) { */
/*   pg_query($database, "rollback"); */
/*   site_epilog($database); */
/*   header("location: admin.php"); */
/*   exit(); */
/* } */

// now remove the photo entries
$result = pg_query($database, "delete from photo where folder='$trash_folder_id[0]'");
if (!$result) {
  pg_query($database, "rollback");
  site_epilog($database);
  header("location: user.php?user=$user_id");
  exit();
}

// first of all remove the thumbnail and image from the filesystem
for ($i=0; $i < $num_of_photos_in_trash; $i++) {
  $drop_this_image = pg_fetch_row($photos_in_trash, $i);
  error_reporting(0);
  unlink($image_repository_path . "/" .$drop_this_image[0]);
  unlink($image_repository_path . "/" .$drop_this_image[1]);
  unlink($image_repository_path . "/" .$drop_this_image[2]);
  error_reporting(1);

  /* if a content based search server is set up, audit the removed images */
  audit_photo($database, $drop_this_image[3], $session_id);
}
pg_query($database, "commit");

site_epilog($database);
header("location: user.php?user=$user_id");
?>
